;***********************************************************************************
; Aladdin 2000 crack by d4s in 2012
;***********************************************************************************

.define BANKSTART $8000

.MEMORYMAP
SLOTSIZE $8000
DEFAULTSLOT 0
SLOT 0 BANKSTART
.ENDME

.ROMBANKSIZE $8000
.ROMBANKS 64

.Background "al2.smc" ;rom without header

/*
protection:
write to $88:xxxx
read bitswapped byte from $80:xxxx
bitswap pattern:
76543210 -> 06712345
*/


.def PROTECTION_BITCOUNT 8


.SNESHEADER
  NAME "ALADDIN 2000"
  LOROM
  FASTROM
  CARTRIDGETYPE 0
  ROMSIZE $b
  SRAMSIZE 0
  COUNTRY 0
  LICENSEECODE $33
  VERSION 0
.ENDSNES



.bank 0 slot 0


;008118 sta [$70],y   [889302] A:00c1 X:8082 Y:0000 S:01ef D:0000 DB:00 NvMxdIzC V:214 H: 294
;00811a lda [$74],y   [808200] A:00c1 X:8082 Y:0000 S:01ef D:0000 DB:00 NvMxdIzC V:214 H: 342
.org $008118 - BANKSTART
  jsl getBitswappedByte

;008124 sta [$70],y   [889302] A:003a X:8082 Y:0000 S:01ef D:0000 DB:00 nvMxdIzC V:214 H: 462
;008126 lda [$74],y   [808200] A:003a X:8082 Y:0000 S:01ef D:0000 DB:00 nvMxdIzC V:214 H: 510
.org $008124 - BANKSTART
  jsl getBitswappedByte

;loads & write different locations, probably wants to see other values
;00a53c sta [$70],y   [889702] A:0180 X:80a2 Y:0000 S:01ec D:0000 DB:00 NvMxdIzc V:217 H:1094
;00a53e lda [$74],y   [80a200] A:0180 X:80a2 Y:0000 S:01ec D:0000 DB:00 NvMxdIzc V:217 H:1142
.org $00a53c - BANKSTART
  jsl getBitswappedByte

;found in rom, but not encountered while executing. Probably leftovers
.org $00c118 - BANKSTART
  jsl getBitswappedByte
.org $00c124 - BANKSTART
  jsl getBitswappedByte
.org $00e118 - BANKSTART
  jsl getBitswappedByte
.org $00e124 - BANKSTART
  jsl getBitswappedByte

.bank $3f slot 0
.org $008118 - BANKSTART
  jsl getBitswappedByte
.org $008124 - BANKSTART
  jsl getBitswappedByte
.org $00a118 - BANKSTART
  jsl getBitswappedByte
.org $00a124 - BANKSTART
  jsl getBitswappedByte
.org $00c118 - BANKSTART
  jsl getBitswappedByte
.org $00c124 - BANKSTART
  jsl getBitswappedByte
.org $00e118 - BANKSTART
  jsl getBitswappedByte
.org $00e124 - BANKSTART
  jsl getBitswappedByte



.bank $d slot 0

;0d82d6 sta [$70],y   [88c412] A:0028 X:0000 Y:0000 S:01e2 D:0000 DB:00 nvMxdIzc V: 22 H: 722
;0d82d8 lda [$74],y   [808060] A:0028 X:0000 Y:0000 S:01e2 D:0000 DB:00 nvMxdIzc V: 22 H: 770
.org $0082d6 - BANKSTART
  jsl getBitswappedByte


;0d938c sta [$70],y   [885212] A:0030 X:0100 Y:0000 S:01e3 D:0000 DB:02 nvMxdIzC V:248 H: 964
;0d938e lda [$74],y   [806360] A:0030 X:0100 Y:0000 S:01e3 D:0000 DB:02 nvMxdIzC V:248 H:1010
.org $00938c - BANKSTART
  jsl getBitswappedByte


.bank $3f slot 0
.org $7f70

/**
* get bitswapped byte
*/
getBitswappedByte:
  php
  rep #$31
  phx
  sep #$20
  pea 0

  ldx #PROTECTION_BITCOUNT
-	rol a
	bcc +
	  pha
	  lda.l protectionBitfield - 1,x
	  ora 2,s
	  sta 2,s
	  pla
+	dex
	bne -

  pla
  xba
  pla
  xba
  plx
  plp
  rtl

;06712345
protectionBitfield:
  .db %10000000
  .db %00010000
  .db %00001000
  .db %00000100
  .db %00000010
  .db %00000001
  .db %01000000
  .db %00100000